﻿using System;

namespace SimpleCalculator
{
    public interface ICalcView
    {
        /// <summary>Occurs when a number button is clicked</summary>
        event Action<int> NumberButtonClicked;
        /// <summary>Occurs when an operator button is clicked</summary>
        event Action<CalcEnums.Operators> OperatorButtonClicked;
        /// <summary>Occurs when the decimal button is clicked</summary>
        event Action DecimalButtonClicked;
        /// <summary>Occurs when the clear button is clicked</summary>
        event Action ClearButtonClicked;
        /// <summary>Occurs when the = button is clicked</summary>
        event Action EqualsButtonClicked;

        /// <summary>Enable/disable the number buttons</summary>
        /// <param name="enable">True to enable. Else disable</param>
        void EnableNumberButtons(bool enable);
        /// <summary>Enable/disable the operator buttons</summary>
        /// <param name="enable">True to enable. Else disable</param>
        void EnableOpButtons(bool enable);
        /// <summary>Enable/disable the = button</summary>
        /// <param name="enable">True to enable. Else disable</param>
        void EnableEq(bool enable);

        /// <summary>Display text on calc screen</summary>
        /// <param name="dispStr">Text to display</param>
        void Display(string dispStr);
        /// <summary>Display an error on the calc screen</summary>
        /// <param name="errorMsg">Error message to display</param>
        void DisplayError(string errorMsg);
    }
}
